/*
 * Copyright 2020 Tadashi G. Takaoka
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "text_ins8070.h"

namespace libasm {
namespace text {
namespace ins8070 {

// clang-format off
constexpr char TEXT_CPU_INS8070[] PROGMEM = "INS8070";
constexpr char TEXT_CPU_8070[]    PROGMEM = "8070";

// constexpr char TEXT_ADD[]  PROGMEM = "ADD";
// constexpr char TEXT_AND[]  PROGMEM = "AND";
constexpr char TEXT_BND[]  PROGMEM = "BND";
// constexpr char TEXT_BNZ[]  PROGMEM = "BNZ";
// constexpr char TEXT_BP[]   PROGMEM = "BP";
// constexpr char TEXT_BRA[]  PROGMEM = "BRA";
// constexpr char TEXT_BZ[]   PROGMEM = "BZ";
// constexpr char TEXT_CALL[] PROGMEM = "CALL";
// constexpr char TEXT_DIV[]  PROGMEM = "DIV";
// constexpr char TEXT_DLD[]  PROGMEM = "DLD";
// constexpr char TEXT_ILD[]  PROGMEM = "ILD";
// constexpr char TEXT_JMP[]  PROGMEM = "JMP";
// constexpr char TEXT_JSR[]  PROGMEM = "JSR";
// constexpr char TEXT_LD[]   PROGMEM = "LD";
// constexpr char TEXT_MPY[]  PROGMEM = "MPY";
// constexpr char TEXT_NOP[]  PROGMEM = "NOP";
// constexpr char TEXT_OR[]   PROGMEM = "OR";
constexpr char TEXT_PLI[]  PROGMEM = "PLI";
// constexpr char TEXT_POP[]  PROGMEM = "POP";
// constexpr char TEXT_PUSH[] PROGMEM = "PUSH";
// constexpr char TEXT_RET[]  PROGMEM = "RET";
// constexpr char TEXT_RRL[]  PROGMEM = "RRL";
// constexpr char TEXT_RR[]   PROGMEM = "RR";
// constexpr char TEXT_SL[]   PROGMEM = "SL";
// constexpr char TEXT_SRL[]  PROGMEM = "SRL";
// constexpr char TEXT_SR[]   PROGMEM = "SR";
constexpr char TEXT_SSM[]  PROGMEM = "SSM";
// constexpr char TEXT_ST[]   PROGMEM = "ST";
// constexpr char TEXT_SUB[]  PROGMEM = "SUB";
// constexpr char TEXT_XCH[]  PROGMEM = "XCH";
// constexpr char TEXT_XOR[]  PROGMEM = "XOR";

// constexpr char TEXT_REG_A[]  PROGMEM  = "A";
// constexpr char TEXT_REG_E[]  PROGMEM  = "E";
constexpr char TEXT_REG_EA[] PROGMEM = "EA";
// constexpr char TEXT_REG_T[]  PROGMEM  = "T";
// constexpr char TEXT_REG_S[]  PROGMEM  = "S";
// constexpr char TEXT_REG_PC[] PROGMEM = "PC";
// constexpr char TEXT_REG_SP[] PROGMEM = "SP";
// constexpr char TEXT_REG_P2[] PROGMEM = "P2";
// constexpr char TEXT_REG_P3[] PROGMEM = "P3";
// clang-format on

}  // namespace ins8070
}  // namespace text
}  // namespace libasm

// Local Variables:
// mode: c++
// c-basic-offset: 4
// tab-width: 4
// End:
// vim: set ft=cpp et ts=4 sw=4:
